Attribute VB_Name = "ModuleByteConversionOld"
Option Explicit

'This is the old method used for converting bytes to floating point values & vice versa.  It uses
'string manipulation and a good deal of math.  It is kept here basically for archiving purposes
'only, but also to show theoretically how to convert between bytes & floating point values.
'An easier method is to use RtlMoveMemory from the kernel32 library to directly copy the bytes
'into a floating point value (or vice versa).  The new method is in ModuleByteConversion.

Const Log2 = 0.69314718056          'Constant- Log of 2

Sub ConvertBytesToSingle( _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte, _
  float As Single _
) 'This sub converts four bytes to a single precision floating point value

  'I know this is a bit redundant doing the same thing four times without a subroutine,
  'but I'm trying to make sure it runs fast enough.  It may not make a difference
  Dim NumberString1 As String
  Dim NumberString2 As String
  Dim NumberString3 As String
  Dim NumberString4 As String
  Dim CombinedString As String
  Dim RunningTotal As Double
  Dim BiasedExponent As Integer
  Dim Mantissa As Double
  Dim NumberString As String
  Dim ctr As Integer
  
  If byte1 = 0 And byte2 = 0 And byte3 = 0 And byte4 = 0 Then
    'Convert the float to 0, instead of 5.87747175411144E-39
    float = 0
  Else
  NumberString = ""
  
    RunningTotal = byte1
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString1 = NumberString1 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString1 = NumberString1 + "0"
      End If
    Next ctr

    RunningTotal = byte2
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString2 = NumberString2 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString2 = NumberString2 + "0"
      End If
    Next ctr

    RunningTotal = byte3
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString3 = NumberString3 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString3 = NumberString3 + "0"
      End If
    Next ctr

    RunningTotal = byte4
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString4 = NumberString4 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString4 = NumberString4 + "0"
      End If
    Next ctr

    If FormMain.CompMode = "PC" Then
      CombinedString = NumberString4 + NumberString3 + NumberString2 + NumberString1
    Else
      CombinedString = NumberString1 + NumberString2 + NumberString3 + NumberString4
    End If

    BiasedExponent = 0
    For ctr = 2 To 9
      If Mid(CombinedString, ctr, 1) = "1" Then
        BiasedExponent = BiasedExponent + 2 ^ (9 - ctr)
      End If
    Next ctr
    BiasedExponent = BiasedExponent - 127
  
    Mantissa = 1
    For ctr = 10 To 32
      If Mid(CombinedString, ctr, 1) = "1" Then
        Mantissa = Mantissa + 2 ^ -(ctr - 9)
      End If
    Next ctr

    float = Mantissa * 2 ^ BiasedExponent
    If Mid(CombinedString, 1, 1) = "1" Then
      float = -float
    End If
  End If 'float=0
End Sub

Sub ConvertSingleToBytes( _
  float As Single, _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte _
) 'This sub converts a value to four bytes for storage as a single precision floating point value
  
  Dim MantissaString As String
  Dim Mantissa As Double
  Dim MantissaTemp As Double
  Dim BiasedExponent As Integer
  Dim Exponent As Integer
  Dim BiasedExponentString As String
  Dim CombinedString As String
  Dim RunningTotal As Integer
  Dim ctr As Integer
  Dim absfloat As Single
    
  If float = 0 Then
    byte1 = 0
    byte2 = 0
    byte3 = 0
    byte4 = 0
  ElseIf float = -999 Then
    'Since -999 will be sent so often, I am including this special case to save the time of
    'having to run through the string manipulation
    If FormMain.CompMode = "PC" Then
      byte1 = 0
      byte2 = 192
      byte3 = 121
      byte4 = 196
    Else
      byte1 = 196
      byte2 = 121
      byte3 = 192
      byte4 = 0
    End If
  Else
    'Find Biased Exponent & Convert to Binary
    Exponent = Int(Log(Abs(float)) / Log2)
    BiasedExponent = Exponent + 127
  
    RunningTotal = BiasedExponent
    BiasedExponentString = ""
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        BiasedExponentString = BiasedExponentString + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        BiasedExponentString = BiasedExponentString + "0"
      End If
    Next ctr
  
  
    'Find Mantissa in binary
    Mantissa = 1
    MantissaString = ""
    absfloat = Abs(float)
    For ctr = 1 To 23
      MantissaTemp = Mantissa + 2 ^ -ctr
      If MantissaTemp * 2 ^ Exponent <= absfloat Then
        MantissaString = MantissaString + "1"
        Mantissa = MantissaTemp
      Else
        MantissaString = MantissaString + "0"
      End If
    Next ctr
  
    If float < 0 Then
      CombinedString = "1" & BiasedExponentString & MantissaString
    Else
      CombinedString = "0" & BiasedExponentString & MantissaString
    End If
  
    FormMain.IntegerCombinedString = CombinedString
  
    If FormMain.CompMode = "PC" Then
      byte1 = 0
      For ctr = 25 To 32
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte1 = byte1 + 2 ^ (32 - ctr)
        End If
      Next ctr

      byte2 = 0
      For ctr = 17 To 24
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte2 = byte2 + 2 ^ (24 - ctr)
         End If
      Next ctr

      byte3 = 0
      For ctr = 9 To 16
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte3 = byte3 + 2 ^ (16 - ctr)
        End If
      Next ctr

      byte4 = 0
      For ctr = 1 To 8
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte4 = byte4 + 2 ^ (8 - ctr)
        End If
      Next ctr
    Else
      byte4 = 0
      For ctr = 25 To 32
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte4 = byte4 + 2 ^ (32 - ctr)
        End If
      Next ctr

      byte3 = 0
      For ctr = 17 To 24
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte3 = byte3 + 2 ^ (24 - ctr)
        End If
      Next ctr

      byte2 = 0
      For ctr = 9 To 16
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte2 = byte2 + 2 ^ (16 - ctr)
        End If
      Next ctr

      byte1 = 0
      For ctr = 1 To 8
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte1 = byte1 + 2 ^ (8 - ctr)
        End If
      Next ctr
    End If 'CompMode = "PC"
  End If 'float = 0
End Sub

Sub ConvertBytesToDouble( _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte, _
  byte5 As Byte, _
  byte6 As Byte, _
  byte7 As Byte, _
  byte8 As Byte, _
  float As Double _
) 'This sub converts four bytes to a single precision floating point value

  'I know this is a bit redundant doing the same thing four times without a subroutine,
  'but I'm trying to make sure it runs fast enough.  It may not make a difference
  Dim NumberString1 As String
  Dim NumberString2 As String
  Dim NumberString3 As String
  Dim NumberString4 As String
  Dim NumberString5 As String
  Dim NumberString6 As String
  Dim NumberString7 As String
  Dim NumberString8 As String
  Dim CombinedString As String
  Dim RunningTotal As Double
  Dim BiasedExponent As Integer
  Dim Exponent As Integer
  Dim Mantissa As Double
  Dim NumberString As String
  Dim ctr As Integer
  
  If byte1 = 0 And byte2 = 0 And byte3 = 0 And byte4 = 0 And byte5 = 0 And byte6 = 0 And byte7 = 0 And byte8 = 0 Then
    'Convert the float to 0, instead of 5.87747175411144E-39
    float = 0
  Else
    NumberString = ""
  
    'Convert the bytes to binary
    RunningTotal = byte1
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString1 = NumberString1 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString1 = NumberString1 + "0"
      End If
    Next ctr

    RunningTotal = byte2
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString2 = NumberString2 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString2 = NumberString2 + "0"
      End If
    Next ctr

    RunningTotal = byte3
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString3 = NumberString3 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString3 = NumberString3 + "0"
      End If
    Next ctr

    RunningTotal = byte4
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString4 = NumberString4 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString4 = NumberString4 + "0"
      End If
    Next ctr
    
    RunningTotal = byte5
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString5 = NumberString5 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString5 = NumberString5 + "0"
      End If
    Next ctr
    
    RunningTotal = byte6
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString6 = NumberString6 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString6 = NumberString6 + "0"
      End If
    Next ctr
    
    RunningTotal = byte7
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString7 = NumberString7 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString7 = NumberString7 + "0"
      End If
    Next ctr
    
    RunningTotal = byte8
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString8 = NumberString8 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString8 = NumberString8 + "0"
      End If
    Next ctr

    If FormMain.CompMode = "PC" Then
      CombinedString = NumberString8 + NumberString7 + NumberString6 + NumberString5 + NumberString4 + NumberString3 + NumberString2 + NumberString1
    Else
      CombinedString = NumberString1 + NumberString2 + NumberString3 + NumberString4 + NumberString5 + NumberString6 + NumberString7 + NumberString8
    End If

    'Debugging
    'CombinedString = "0100000000001001001000011111101101010100010001000010110100011000"

    BiasedExponent = 0
    For ctr = 2 To 12
      If Mid(CombinedString, ctr, 1) = "1" Then
        BiasedExponent = BiasedExponent + 2 ^ (12 - ctr)
      End If
    Next ctr
    Exponent = BiasedExponent - 1023
  
    Mantissa = 1
    For ctr = 13 To 64
      If Mid(CombinedString, ctr, 1) = "1" Then
        Mantissa = Mantissa + 2 ^ -(ctr - 12)
      End If
    Next ctr

    float = Mantissa * 2 ^ Exponent
    If Mid(CombinedString, 1, 1) = "1" Then
      float = -float
    End If
  End If 'float=0
End Sub

Sub ConvertDoubleToBytes( _
  float As Double, _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte, _
  byte5 As Byte, _
  byte6 As Byte, _
  byte7 As Byte, _
  byte8 As Byte _
) 'This sub converts a number to eight bytes for storage as a double precision floating point value
  
  Dim MantissaString As String
  Dim Mantissa As Double
  Dim MantissaTemp As Double
  Dim BiasedExponent As Integer
  Dim Exponent As Integer
  Dim BiasedExponentString As String
  Dim CombinedString As String
  Dim RunningTotal As Integer
  Dim ctr As Integer
  Dim absfloat As Double
  Dim TestNumber3 As Double
    
  If float = 0 Then
    byte1 = 0
    byte2 = 0
    byte3 = 0
    byte4 = 0
    byte5 = 0
    byte6 = 0
    byte7 = 0
    byte8 = 0
  Else
    'Find Biased Exponent & Convert to Binary
    Exponent = Int(Log(Abs(float)) / Log2)
    BiasedExponent = Exponent + 1023
  
    RunningTotal = BiasedExponent
    BiasedExponentString = ""
    For ctr = 1 To 11
      If RunningTotal >= 2 ^ (11 - ctr) Then  '11 because the biased exponent for a double is 11 binary digits long
        BiasedExponentString = BiasedExponentString + "1"
        RunningTotal = RunningTotal - 2 ^ (11 - ctr)
      Else
        BiasedExponentString = BiasedExponentString + "0"
      End If
    Next ctr
  
  
    'Find Mantissa in binary
    Mantissa = 1
    MantissaString = ""
    absfloat = Abs(float)
    For ctr = 1 To 52
      MantissaTemp = Mantissa + 2 ^ -ctr
      If MantissaTemp * 2 ^ Exponent <= absfloat Then
        MantissaString = MantissaString + "1"
        Mantissa = MantissaTemp
      Else
        MantissaString = MantissaString + "0"
      End If
    Next ctr
  
    If float < 0 Then
      CombinedString = "1" & BiasedExponentString & MantissaString
    Else
      CombinedString = "0" & BiasedExponentString & MantissaString
    End If
  
    If FormMain.CompMode = "PC" Then
      byte1 = 0
      For ctr = 57 To 64
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte1 = byte1 + 2 ^ (64 - ctr)
        End If
      Next ctr
      
      byte2 = 0
      For ctr = 49 To 56
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte2 = byte2 + 2 ^ (56 - ctr)
        End If
      Next ctr
      
      byte3 = 0
      For ctr = 41 To 48
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte3 = byte3 + 2 ^ (48 - ctr)
        End If
      Next ctr
      
      byte4 = 0
      For ctr = 33 To 40
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte4 = byte4 + 2 ^ (40 - ctr)
        End If
      Next ctr
      
      byte5 = 0
      For ctr = 25 To 32
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte5 = byte5 + 2 ^ (32 - ctr)
        End If
      Next ctr

      byte6 = 0
      For ctr = 17 To 24
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte6 = byte6 + 2 ^ (24 - ctr)
         End If
      Next ctr

      byte7 = 0
      For ctr = 9 To 16
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte7 = byte7 + 2 ^ (16 - ctr)
        End If
      Next ctr

      byte8 = 0
      For ctr = 1 To 8
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte8 = byte8 + 2 ^ (8 - ctr)
        End If
      Next ctr
    Else
      byte8 = 0
      For ctr = 57 To 64
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte8 = byte8 + 2 ^ (64 - ctr)
        End If
      Next ctr
      
      byte7 = 0
      For ctr = 49 To 56
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte7 = byte7 + 2 ^ (56 - ctr)
        End If
      Next ctr
      
      byte6 = 0
      For ctr = 41 To 48
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte6 = byte6 + 2 ^ (48 - ctr)
        End If
      Next ctr
      
      byte5 = 0
      For ctr = 33 To 40
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte5 = byte5 + 2 ^ (40 - ctr)
        End If
      Next ctr
    
      byte4 = 0
      For ctr = 25 To 32
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte4 = byte4 + 2 ^ (32 - ctr)
        End If
      Next ctr

      byte3 = 0
      For ctr = 17 To 24
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte3 = byte3 + 2 ^ (24 - ctr)
        End If
      Next ctr

      byte2 = 0
      For ctr = 9 To 16
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte2 = byte2 + 2 ^ (16 - ctr)
        End If
      Next ctr

      byte1 = 0
      For ctr = 1 To 8
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte1 = byte1 + 2 ^ (8 - ctr)
        End If
      Next ctr
    End If 'CompMode = "PC"
  End If 'float = 0
End Sub

Sub ConvertBytesToSingleAndStrings( _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte, _
  float As Single, _
  string1 As String, _
  string2 As String, _
  string3 As String, _
  string4 As String _
) 'This sub converts four bytes to a single precision floating point value

  'I know this is a bit redundant doing the same thing four times without a subroutine,
  'but I'm trying to make sure it runs fast enough.  It may not make a difference
  Dim NumberString1 As String
  Dim NumberString2 As String
  Dim NumberString3 As String
  Dim NumberString4 As String
  Dim CombinedString As String
  Dim RunningTotal As Double
  Dim BiasedExponent As Integer
  Dim Mantissa As Double
  Dim NumberString As String
  Dim ctr As Integer
  
  If byte1 = 0 And byte2 = 0 And byte3 = 0 And byte4 = 0 Then
    'Convert the float to 0, instead of 5.87747175411144E-39
    float = 0
  Else
  NumberString = ""
  
    RunningTotal = byte1
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString1 = NumberString1 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString1 = NumberString1 + "0"
      End If
    Next ctr

    RunningTotal = byte2
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString2 = NumberString2 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString2 = NumberString2 + "0"
      End If
    Next ctr

    RunningTotal = byte3
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString3 = NumberString3 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString3 = NumberString3 + "0"
      End If
    Next ctr

    RunningTotal = byte4
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        NumberString4 = NumberString4 + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        NumberString4 = NumberString4 + "0"
      End If
    Next ctr

    If FormMain.CompMode = "PC" Then
      CombinedString = NumberString4 + NumberString3 + NumberString2 + NumberString1
      string1 = NumberString4
      string2 = NumberString3
      string3 = NumberString2
      string4 = NumberString1
    Else
      CombinedString = NumberString1 + NumberString2 + NumberString3 + NumberString4
      string1 = NumberString1
      string2 = NumberString2
      string3 = NumberString3
      string4 = NumberString4
    End If

    BiasedExponent = 0
    For ctr = 2 To 9
      If Mid(CombinedString, ctr, 1) = "1" Then
        BiasedExponent = BiasedExponent + 2 ^ (9 - ctr)
      End If
    Next ctr
    BiasedExponent = BiasedExponent - 127
  
    Mantissa = 1
    For ctr = 10 To 32
      If Mid(CombinedString, ctr, 1) = "1" Then
        Mantissa = Mantissa + 2 ^ -(ctr - 9)
      End If
    Next ctr

    float = Mantissa * 2 ^ BiasedExponent
    If Mid(CombinedString, 1, 1) = "1" Then
      float = -float
    End If
  End If 'float=0
End Sub

Sub ConvertSingleToBytesAndStrings( _
  float As Single, _
  byte1 As Byte, _
  byte2 As Byte, _
  byte3 As Byte, _
  byte4 As Byte, _
  string1 As String, _
  string2 As String, _
  string3 As String, _
  string4 As String _
) 'This sub converts a value to four bytes for storage as a single precision floating point value
  
  Dim MantissaString As String
  Dim Mantissa As Double
  Dim MantissaTemp As Double
  Dim BiasedExponent As Integer
  Dim Exponent As Integer
  Dim BiasedExponentString As String
  Dim CombinedString As String
  Dim RunningTotal As Integer
  Dim ctr As Integer
  Dim absfloat As Single
    
  string1 = ""
  string2 = ""
  string3 = ""
  string4 = ""
    
  If float = 0 Then
    byte1 = 0
    byte2 = 0
    byte3 = 0
    byte4 = 0
    string1 = "00000000"
    string2 = "00000000"
    string3 = "00000000"
    string4 = "00000000"
  ElseIf float = -999 Then
    'Since -999 will be sent so often, I am including this special case to save the time of
    'having to run through the string manipulation
    If FormMain.CompMode = "PC" Then
      byte1 = 0
      byte2 = 192
      byte3 = 121
      byte4 = 196
      string1 = "00000000"
      string2 = "11000000"
      string3 = "01111001"
      string4 = "11000100"
    Else
      byte1 = 196
      byte2 = 121
      byte3 = 192
      byte4 = 0
      string1 = "11000100"
      string2 = "01111001"
      string3 = "11000000"
      string4 = "00000000"
    End If
  Else
    'Find Biased Exponent & Convert to Binary
    Exponent = Int(Log(Abs(float)) / Log2)
    BiasedExponent = Exponent + 127
  
    RunningTotal = BiasedExponent
    BiasedExponentString = ""
    For ctr = 1 To 8
      If RunningTotal >= 2 ^ (8 - ctr) Then
        BiasedExponentString = BiasedExponentString + "1"
        RunningTotal = RunningTotal - 2 ^ (8 - ctr)
      Else
        BiasedExponentString = BiasedExponentString + "0"
      End If
    Next ctr
  
  
    'Find Mantissa in binary
    Mantissa = 1
    MantissaString = ""
    absfloat = Abs(float)
    For ctr = 1 To 23
      MantissaTemp = Mantissa + 2 ^ -ctr
      If MantissaTemp * 2 ^ Exponent <= absfloat Then
        MantissaString = MantissaString + "1"
        Mantissa = MantissaTemp
      Else
        MantissaString = MantissaString + "0"
      End If
    Next ctr
  
    If float < 0 Then
      CombinedString = "1" & BiasedExponentString & MantissaString
    Else
      CombinedString = "0" & BiasedExponentString & MantissaString
    End If
  
    FormMain.IntegerCombinedString = CombinedString
  
    If FormMain.CompMode = "PC" Then
      byte1 = 0
      For ctr = 25 To 32
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte1 = byte1 + 2 ^ (32 - ctr)
          string1 = string1 & "1"
        Else
          string1 = string1 & "0"
        End If
      Next ctr

      byte2 = 0
      For ctr = 17 To 24
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte2 = byte2 + 2 ^ (24 - ctr)
          string2 = string3 & "1"
        Else
          string2 = string2 & "0"
         End If
      Next ctr

      byte3 = 0
      For ctr = 9 To 16
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte3 = byte3 + 2 ^ (16 - ctr)
          string3 = string3 & "1"
        Else
          string3 = string3 & "0"
        End If
      Next ctr

      byte4 = 0
      For ctr = 1 To 8
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte4 = byte4 + 2 ^ (8 - ctr)
          string4 = string4 & "1"
        Else
          string4 = string4 & "0"
        End If
      Next ctr
    Else
      byte4 = 0
      For ctr = 25 To 32
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte4 = byte4 + 2 ^ (32 - ctr)
          string4 = string4 & "1"
        Else
          string4 = string4 & "0"
        End If
      Next ctr

      byte3 = 0
      For ctr = 17 To 24
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte3 = byte3 + 2 ^ (24 - ctr)
          string3 = string3 & "1"
        Else
          string3 = string3 & "0"
        End If
      Next ctr

      byte2 = 0
      For ctr = 9 To 16
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte2 = byte2 + 2 ^ (16 - ctr)
          string2 = string2 & "1"
        Else
          string2 = string2 & "0"
        End If
      Next ctr

      byte1 = 0
      For ctr = 1 To 8
        If Mid(CombinedString, ctr, 1) = "1" Then
          byte1 = byte1 + 2 ^ (8 - ctr)
          string1 = string1 & "1"
        Else
          string1 = string1 & "0"
        End If
      Next ctr
    End If 'CompMode = "PC"
  End If 'float = 0
End Sub


